// support code for Eeek!  XML!  Over at MacEdition
// http://macedition.com/bolts/bolts_20030610.php

// this code is in the public domain.  have fun.

#import "XMLNode.h"


@implementation XMLNode


- (id) init
{
    if (self = [super init]) {
	children = [[NSMutableArray alloc] init];
    }

    return (self);

} // init



// clean up our mess

- (void) dealloc
{
    [attributes release];
    [children release];
    [type release];

} // dealloc



- (void) addChild: (XMLNode *) node
{
    [children addObject: node];
} // addChild



- (void) setAttributes: (NSDictionary *) newAttributes
{
    if (attributes != newAttributes) {
	[attributes release];
	// make a copy since the original will go away
	attributes = [newAttributes copy];
    }

} // setAttributes



- (void) setType: (NSString *) newType
{
    if (type != newType) {
	[type release];
	type = [newType copy];
    }

} // setType



// create a string that describes this particular node
// this recurses, adding the children

- (NSString *) description
{
    NSMutableString *string;
    
    string = [[NSMutableString alloc] init];

    [string appendString: @"XMLNode. type: "];
    [string appendString: type];

    if (attributes != nil) {
	[string appendString: @"   attributes: "];
	[string appendString: [attributes description]];
    }

    [string appendString: @"   children: "];
    [string appendString: [children description]];

    return ([string autorelease]);

} // description


@end // XMLNode

